@use "@/theme/base.scss";

$family-monospace: var(--mono-font-family);
$code: var(--bright);
$match-background: var(--background-color);
$match-background-winner: var(--primary-focus);
$body-color: var(--color);
$border: var(--box-border-color);
$border-hover: var(--bright);

.elimBracket {
  @include base.depressed;
  position: relative;
  width: 100%;
  height: 100%;
  overflow: hidden;
  display: grid;
  touch-action: none;
  @include base.mq($until: tablet) {
    min-height: 60vh;
  }
  cursor: var(--cursor);
}

svg.elimBracketSvg {
  align-self: center;
  justify-self: center;
  shape-rendering: geometricPrecision;
  transform: scale(var(--zoom-scale)) translate(var(--zoom-x), var(--zoom-y));
  max-width: var(--viewbox-width);
  max-height: var(--viewbox-height);
}

.buttons {
  position: absolute;
  bottom: var(--spacing); // there is margin on the buttons
  right: var(--spacing);
  display: grid;
  grid: "in out";
  gap: var(--spacing);
}

.elimMatchId {
  font: calc(0.7 * var(--font-size)) var(--font-family-mono);
  z-index: 40;
  stroke: none;
  fill: $code;
  color: $code;
}

.elimMatchRect {
  fill: $match-background;
}

.elimMatchRow {
  &[data-winner="false"] {
    .elimSignup {
      opacity: 0.66;
    }
  }
  &[data-winner="true"] {
    font-weight: bold;
  }
}

.elimWinnerBg {
  rx: 5px;
  ry: 5px;
  fill: $match-background-winner;
}

g.elimRoundLabels {
  fill: var(--bright);
  font: calc(0.7 * var(--font-size)) var(--font-family);
  font-weight: bold;
  z-index: 40;
  dominant-baseline: hanging;
  text-anchor: middle;
}

@keyframes dropAnimate {
  to {
    stroke-dashoffset: -1000;
  }
}

g.elimDropPaths {
  stroke: $border;
  stroke-width: 1;
  stroke-linejoin: round;
  stroke-opacity: 1;
  stroke-dasharray: 4 4;
  stroke-dashoffset: 0;
  fill: none;
  z-index: 0;
  > path[data-highlight="true"] {
    stroke: $border-hover;
    stroke-width: 2;
    animation: dropAnimate 50s linear infinite;
  }
}

g.elimMatchPaths {
  stroke: $border;
  stroke-width: 2;
  stroke-linejoin: round;
  stroke-opacity: 1;
  fill: none;
}

g.elimMatches {
  // stroke: $background;
  // fill: $background;
  filter: url(#shadow);
  stroke-width: 4;
  z-index: 1;
  stroke-linejoin: round;
  stroke-opacity: 1;
}

g.elimMatchGroup {
  rx: 4px;
  ry: 4px;
  &[data-highlight="true"] {
    cursor: pointer;
  }
}

rect.elimMatchRect {
  rx: 4px;
  ry: 4px;
}

rect.elimMatchOutlineRect {
  transition: ease 0.1s stroke, stroke-width;
  rx: 4px;
  ry: 4px;
  stroke-width: 1;
  stroke: $border;
  fill: none;
  g.elimMatchGroup[data-highlight="true"] > & {
    stroke: $border-hover;
    stroke-width: 2;
  }
}

.elimSignup {
  fill: var(--primary);
  dominant-baseline: middle;
  text-anchor: start;
  &:hover {
    fill: var(--primary-hover);
  }
  // https://bugs.chromium.org/p/chromium/issues/detail?id=352912
  > a:visited,
  > a {
    fill: var(--primary);
  }
}

text.elimScore {
  font: calc(0.9 * var(--font-size)) var(--font-family-mono);
  text-anchor: end;
  dominant-baseline: middle;
  &[data-winner-loss="true"] {
    opacity: 0.66;
  }
  &[data-loser-win="false"] {
    opacity: 0.66;
  }
}

g.elimMatchContent {
  stroke: none;
  fill: $body-color;
}
